﻿using Syncfusion.Data;
using Syncfusion.UI.Xaml.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Dynamic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SfDataGridSample
{
    public class ViewModel : INotifyPropertyChanged
    {
        public EmployeeInfoRespository repository;
        public int Count = 5;        

        public int GetCount()
        {
            return Count;
        }

        public ViewModel()
        {
            repository = new EmployeeInfoRespository();            
        }

        public void RaisePropertyChanged(string propName)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(propName));
        }

        public event PropertyChangedEventHandler PropertyChanged;
    }

    public class DTViewModel : ViewModel
    {
        private ObservableCollection<dynamic> itemsCollection;
        public DTViewModel()
            : base()
        {            
            var dataTable = repository.GetEmployeesDetails_DataTable(GetCount());
            ItemsCollection = dataTable.ToDynamic();      
        }

        public ObservableCollection<dynamic> ItemsCollection
        {
            get { return itemsCollection; }
            set
            {
                itemsCollection = value;
                RaisePropertyChanged("ItemsCollection");
            }
        }

        private DataTable companies;

        public DataTable Companies
        {
            get { return companies; }
            set { companies = value; }
        }

    }
    public static class DataTableExtensions
    {
        public static ObservableCollection<dynamic> ToDynamic(this DataTable dt)
        {
            var dynamicDt = new ObservableCollection<dynamic>();
            foreach (System.Data.DataRow row in dt.Rows)
            {
                dynamic dyn = new ExpandoObject();
                dynamicDt.Add(dyn);
                foreach (System.Data.DataColumn column in dt.Columns)
                {
                    var dic = (IDictionary<string, object>)dyn;
                    dic[column.ColumnName] = row[column];
                }
            }
            return dynamicDt;
        }
    }
}
